/*! 
 *  \file hmi_driver.h
 *  \brief ļ
 *  \version 1.0
 *  \date 2012-2017
 *  \copyright hunda tech
 */

#ifndef _HMI_DRIVER_
#define _HMI_DRIVER_

#define CMD_MAX_SIZE 65        /*!<ָСҪôһЩ*/
#define QUEUE_MAX_SIZE 256//128   /*!< ָջСҪôһЩ*/

#define I2C_IF

#include "hmi_user_uart.h"
#include "I2C.h"


/*! 
 *  \brief  ʱ
 *  \param  n ʱʱ(뵥λ)
 */
void DelayMS(unsigned int n);

/*! 
 *  \brief  
 */
void SetConnect(void);
/*! 
 *  \brief  ʾλ
 */
void SetReset(void);

/*! 
 *  \brief     ͼƬȫʾ
 *  \param  x λX
 *  \param  y λY
 *  \param  image_id ͼƬ
 */
void Display_Image(uint16 x,uint16 y,uint8 image_id);

/*! 
 *  \brief     ͼƬͼʾ
 *  \param  image_x ͼx
 *  \param  image_y ͼY
 *  \param  image_w ͼ
 *  \param  image_h ͼ߶
 *  \param  image_id ͼƬ
 */
void DisplayCut_Image(uint16 image_x,uint16 image_y,uint16 image_w, uint16 image_h,uint8  image_id);


/*! 
 *  \brief  
 */
void GUI_CleanScreen(uint16 color);

/*! 
 *  \brief  ùɫ
 *  \param  x λX
 *  \param  y λY
 *  \param  DisplayType
 *  \param  FontSize 
 *  \param  ImageNo ͼƬ
 *  \param  BackColor 屳ɫ
 *  \param  ForeColor ɫ
 *  \param  strings ַ
 */
void Display_String(uint16 x, uint16 y,uint8 DisplayType,uint8 FontSize,uint8 ImageNo,uint16 BackColor,uint16 ForeColor, uchar *strings );


/*! 
 *  \brief    Ϣʾ
 *  \param  FontSize  ַС
 *  \param  time   ʾӳʱ䣬Ϊλ
 *  \param  strings ַ
 */
void Display_Message(uint8 FontSize,uint8 time,uchar *strings );

/*! 
 *  \brief      
 *  \param  x0 ʼλX
 *  \param  y0 ʼλY
 *  \param  x1 λX
 *  \param  y1 λY
 *  \param ForeColor ֱɫ
 */
void GUI_Line(uint16 x0, uint16 y0, uint16 x1, uint16 y1,uint16 ForeColor);


/*! 
 *  \brief      ľ
 *  \param  x0 ʼλX
 *  \param  y0 ʼλY
 *  \param  x1 λX
 *  \param  y1 λY
 *  \param ForeColor ɫ
 */
void GUI_Rectangle(uint16 x0, uint16 y0, uint16 x1,uint16 y1 ,uint16 ForeColor);

/*! 
 *  \brief      ʵľ
 *  \param  x0 ʼλX
 *  \param  y0 ʼλY
 *  \param  x1 λX
 *  \param  y1 λY
 *  \param ForeColor ɫ
 */
void GUI_RectangleFill(uint16 x0, uint16 y0, uint16 x1,uint16 y1 ,uint16 ForeColor);



/*! 
 *  \brief      ñ
 *  \param light_level ֵ
 */
void SetBackLight(uint8 light_level);

/*! 
 *  \brief   
 *  \param enable ʹ
 */
void SetTouchPaneOption(uint8 enbale);

/*! 
 *  \brief   У׼
 */
void	CalibrateTouchPane(void);

/*! 
 *  \brief  
 *  \param enable ʹ
 */
void TestTouchPane(uint8 enbale);




/*! 
 *  \brief      õǰ
 *  \param  page_id ID
 */
void SetPage(uint8 page_id);

/*! 
 *  \brief      ȡǰ
 */
void GetPage(void);


/*! 
 *  \brief     ıֵ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 *  \param  str ıֵ
 */
void SetLableValue(uint8 page_id,uint8 control_id,uchar *str);
/*! 
 *  \brief     ֿؼֵ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 *  \param  numberֵ
 */
void SetNumberValue(uint8 page_id,uint8 control_id,uint16 number);

/*! 
 *  \brief     ñ༭ؼֵ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 *  \param  str ıֵ
 */
void SetEditValue(uint8 page_id,uint8 control_id,uchar *str);

/*! 
 *  \brief     ȡ༭ؼֵ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 */
void GetEditValue(uint8 page_id,uint8 control_id);

/*! 
 *  \brief     ȡ༭ؼֵ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 */
void GetTouchEditValue(uint8 page_id,uint8 control_id);
/*! 
 *  \brief      ýֵ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 *  \param  value ֵ
 */
void SetProgressbarValue(uint8 page_id,uint8 control_id,uint8 value);

/*! 
 *  \brief      øѡֵ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 *  \param  value ֵ
 */
void SetCheckboxValue(uint8 page_id,uint8 control_id,uint8 value);

/*! 
 *  \brief      ȡѡֵ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 */
void GetCheckboxValue(uint8 page_id,uint8 control_id);

/*! 
 *  \brief     ָؼֵ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 *  \param  value ֵ
 */
void SetCircleGaugeValue(uint8 page_id,uint8 control_id,uint16 value);
/*! 
 *  \brief     ñ߿ؼֵ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 *  \param  value ֵ
 */
void SetBarGaugeValue(uint8 page_id,uint8 control_id,uint16 value);
/*! 
 *  \brief     ˮλƿؼֵ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 *  \param  value ֵ
 */
void SetWaterGaugeValue(uint8 page_id,uint8 control_id,uint16 value);
/*! 
 *  \brief     ¶ȼƿؼֵ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 *  \param  value ֵ
 */
void SetThermometerValue(uint8 page_id,uint8 control_id,uint16 value);
/*! 
 *  \brief     õؿؼֵ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 *  \param  value ֵ
 */
void SetBatteryValue(uint8 page_id,uint8 control_id,uint16 value);
/*! 
 *  \brief     ߲οؼֵ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 *  \param  channelNo ͨ
 *  \param  value ֵ
 */
void SetWaveformValue(uint8 page_id,uint8 control_id,uint8 channelNo,uint8 value);
/*! 
 *  \brief     ߲οؼ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 */
void WaveformDataClear(uint8 page_id,uint8 control_id);
/*! 
 *  \brief     ߲οؼֵ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 *  \param  channelNo ͨ
 *  \param  value ֵ
 */
void WaveformDataInsert(uint8 page_id,uint8 control_id,uint8 channelNo,uint8 value);
/*! 
 *  \brief     ˢ߲οؼֵ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 *  \param  channelNo ͨ
 */
void WaveformDataRefress(uint8 page_id,uint8 control_id,uint8 channelNo);

/*! 
 *  \brief      û
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 *  \param  value ֵ
 */
void SetSliderValue(uint8 page_id,uint8 control_id,uint8 value);
/*! 
 *  \brief      ȡλ
 *  \param  page_id ҳID
 *  \param  control_id ؼID
 */
void GetSliderValue(uint8 page_id,uint8 control_id);


void SendNU8(uint8 *pData,uint16 nDataLen);



#endif

